@echo off
SETLOCAL ENABLEEXTENSIONS ENABLEDELAYEDEXPANSION

rem these values need adjustment:
rem Set this to the right device. "cdrecord -scanbus" is your friend
set CDR_DEVICE=1,0,0
rem Maximum CD writing speed in multiple of 150k/s
set CD_SPEED=32
rem Maximum DvD writing speed in multiple of 1.3MB/s
set DVD_SPEED=12
rem RAM-Buffer FiFo size
set CDR_FIFOSIZE=128m

rem you should not need to edit anything below this line

for %%? in (*.iso) do (
  SET ISONAME=%%?
  :burn
  echo/
  echo =========================================================================
  echo Schreibe: "!ISONAME!"
  echo =========================================================================
  echo Bitte leeren Rohling einlegen.
  echo =========================================================================
  echo/
  rem wait until an empty disk is in the drive
  :wait
  rem isoinfo needs to be used because it does not close the tray
  "%~sdp0isoinfo" dev=%CDR_DEVICE% -d 2>&1|find /i "(medium not present" >NUL && (
    rem ping waits one second
    ping -n 1 127.0.0.1>nul
    goto wait
  )
  rem check if medium is empty
  "%~sdp0cdrecord" -minfo 2>&1|find /i "disk status:              empty" >NUL || (
    echo ##########################################
    echo Fehler: Das Medium ist NICHT leer!
    echo ##########################################
:eject
    rem eject tray
    "%~sdp0cdrecord" -eject 1>NUL 2>NUL
    goto burn
  )
  rem Get CD/DvD Type and set write speed
  set CDR_SPEED=%CD_SPEED%
  "%~sdp0cdrecord" -minfo 2>&1|find /i "Mounted media class:      DVD" >NUL && CDR_SPEED=%DVD_SPEED%
  rem write ISO to CD/DvD
  "%~sdp0cdrecord" -dao -gracetime=2 -s driveropts=burnfree "!ISONAME!" || (
    echo ##########################################
    echo Schreibfehler!
    echo ##########################################
    goto eject
  )
  echo/
  echo =========================================================================
  echo Ok.
  echo =========================================================================
  echo/
)
if "%ISONAME%"=="" (
  echo/
  echo =========================================================================
  echo Fehler: Keine ISO-Dateien gefunden!
  echo -------------------------------------------------------------------------
  echo/
  echo %~nx0 kopiert alle ISO-Dateien im aktuellen Ordner auf CD/DvD
  echo/
  echo =========================================================================
  echo/
  pause
)